#!/bin/sh

#prototype only.  not working code.

# This program gathers information about an installed HOOPLE system.  All
# of the configuration files and diagnostic logs are gathered up.
# Author: Chris Koeritz
# Version 0.1 [3/8/2004])

# this is the zip file we will be creating.
export OUTZIP="~/hoople_state_$HOST.zip"

if [ -z "$1" ]; then
  echo "This script should be passed the HOOPLE installation directory"
  echo "as the first parameter.  All of the interesting configuration and"
  echo "diagnostics files from the installation will be gathered into a"
  echo "zip file named \"$OUTZIP\"."
  exit 1;
fi

export INSTALLATION="$1"

#echo "installed location: $INSTALLATION"

# ensure that the installation directory is present.
if [ ! -d "$INSTALLATION" ]; then
  echo "The location specified ($INSTALLATION) does not exist."
  exit 1;
fi

# we'll hide our files in this directory while we're building the archive.
export TEMPORARY=~/.junk_for_gather
rm -rf $TEMPORARY
mkdir $TEMPORARY

# get all the log files.
cp -R "$INSTALLATION/logs" $TEMPORARY

# hmmm: wouldn't it be nice to toss out the name "exe" and instead use
#       a nicer name like "bin"?

# grab all the configuration files.
mkdir $TEMPORARY/exe
cp "$INSTALLATION/exe/"*ini $TEMPORARY/exe

# now zip up the files from the temporary area.
cd $TEMPORARY
zip -rm $OUTZIP exe logs

# clean up the temporary directory.  we should be able to just remove the
# directory since the files should have been slorped up into the zip file.
rmdir $TEMPORARY

echo "The HOOPLE installation's important files have now been gathered."
echo "They reside in a file called $OUTZIP."

