#!/bin/bash
# play the sound files specified.
if [ $# -lt 1 ]; then
  #echo no sound file specified.
  exit 0;
fi
PLAYCMD=play
if [ ! -z "`ps wuax | grep artsd`" ]; then
  # we see artsd running...
  PLAYCMD=artsplay
fi
if [ ! -z "`ps wuax | grep 'esd ' `" ]; then
  # we see esd running...
  PLAYCMD=esdplay
fi
if [ "$OP_SYSTEM" = "WIN32" ]; then
  # kludge for win32; we provide our own sound player.
  PLAYCMD=playsound
fi
# play the sounds individually; playsound can handle multiple files, but
# "play" doesn't want to on some systems.
for i in $*; do $PLAYCMD $i; done
exit 0;
