#ifndef SHELL_SORT_CLASS
#define SHELL_SORT_CLASS

/*****************************************************************************\
*                                                                             *
*  Name   : shell_sort                                                        *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 1991-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "definitions.h"

//! Orders an array in O(n log n) time.
/*!
  Credits:
    This is based on Kernighan and Ritchie's "The C Programming Language"
    (found on page 62 in my edition).
*/

template <class type> void shell_sort(type v[], int n, bool reverse = false);
  //!< this function sorts a C array of the "type" with "n" elements.
  /*!< the "type" of object must support comparison operators.  if "reverse"
  is true, then the list is sorted highest to lowest. */

#endif

