#ifndef DATA_STRUCTURES_DLL_DEFINITIONS
#define DATA_STRUCTURES_DLL_DEFINITIONS

/*****************************************************************************\
*                                                                             *
*  Name   : data structures DLL helper                                        *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 1995-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

/*! @file data_structure_dll.h
  @brief Allows the library to work within a DLL.
*/

#include <basis/build_configuration.h>

// define BUILD_DATA_STRUCTURE when you are creating the dll and
// define USE_HOOPLE_DLLS when you are importing a class from the dll.
#if defined(BUILD_DATA_STRUCTURE)
  #define DATA_STRUCTURE_CLASS_STYLE    HOOPLE_DLL_EXPORT_CLASS
  #define DATA_STRUCTURE_FUNCTION_STYLE HOOPLE_DLL_EXPORT_FUNCTION
#elif defined(USE_HOOPLE_DLLS)
  #define DATA_STRUCTURE_CLASS_STYLE    HOOPLE_DLL_IMPORT_CLASS
  #define DATA_STRUCTURE_FUNCTION_STYLE HOOPLE_DLL_IMPORT_FUNCTION
#else
  #define DATA_STRUCTURE_CLASS_STYLE
  #define DATA_STRUCTURE_FUNCTION_STYLE
#endif

#endif

