#ifndef MATHEMATICS_COMMON_TEMPLATES_GROUP
#define MATHEMATICS_COMMON_TEMPLATES_GROUP

/*****************************************************************************\
*                                                                             *
*  Name   : frequently useful templates                                       *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 2000-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "averager.cpp"

/*! @file common_templates.h
  @brief Provides definitions of useful templated mathematical support.

  As a result of the template usages, this is a pretty heavy-weight header
  and it should really only be used from implementation (.CPP) files.
*/

////////////////////////////////////////////////////////////////////////////

//! keeps an average on a stream of integers.
class int_averager : public averager<int>
{
public:
  int_averager(int entries = 100, bool compacting = true)
          : averager<int>(entries, compacting) {}
};

////////////////////////////////////////////////////////////////////////////

#endif

