/*****************************************************************************\
*                                                                             *
*  Name   : mathematical operations                                           *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 2002-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "math_ops.h"

namespace mathematics {

int round_it(float to_round)
{
  int to_return = int(to_round);
  // this uses a simplistic view of rounding.
  if (to_round - float(to_return) > 0.5) to_return++;
  return to_return;
}

int round_it(double to_round)
{
  int to_return = int(to_round);
  // this uses a simplistic view of rounding.
  if (to_round - double(to_return) > 0.5) to_return++;
  return to_return;
}

u_int pow_2(const u_int raise_to)
{
  if (!raise_to) return 1;
  u_int to_return = 2;
  for (u_int i = 1; i < raise_to; i++)
    to_return *= 2;
  return to_return;
}

} // namespace

