/*****************************************************************************\
*                                                                             *
*  Name   : hysteresis                                                        *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 1998-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "hysteresis.h"

#include <basis/istring.h>

bool hysteresis::time_to_process() { return (_end_of_wait < time_stamp())
 || (_last_event < time_stamp(-_staleness_period)); }

istring hysteresis::text_form() const
{
  return istring(istring::SPRINTF, "staleness_period=%d, longest_delay=%d, "
      "end_of_wait=", _staleness_period, _longest_delay)
      + _end_of_wait.text_form() + istring(", last_event=")
      + _last_event.text_form();
}


