#ifndef HYSTERESIS_CLASS
#define HYSTERESIS_CLASS

// EXPERIMENTAL CODE: may not work very well or at all yet!

/*****************************************************************************\
*                                                                             *
*  Name   : hysteresis                                                        *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 1998-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "time_stamp.h"

//! Provides a mechanism for responding to events with relaxed timing.
/*!
  Rather than triggering right away and possibly flipping back and forth
  quickly once a threshold is reached, the hysteresis object will allow
  more time to pass before the decision to flip is made.
*/

class MECHANISMS_CLASS_STYLE hysteresis
{
public:
  inline hysteresis(int staleness_period, int longest_delay)
  : _staleness_period(staleness_period),
    _last_event(-staleness_period*2), 
    _longest_delay(longest_delay),
    _end_of_wait() {}

  inline void record_event() { _last_event = time_stamp(); }
    //!< records that we have just seen an event.

  inline void reset_waiter() { _end_of_wait = time_stamp(_longest_delay); }
    //!< resets the timestamp to indicate that we have just handled an event.

  //! returns true if it is time to do some processing now.
  /*! this will happen if the last_event has languished too long or if the
  period we've been delaying has gotten too large. */
  bool time_to_process();

  istring text_form() const;

  int _staleness_period;
  time_stamp _last_event;
  int _longest_delay;
  time_stamp _end_of_wait;
};

#endif

