/*****************************************************************************\
*                                                                             *
*  Name   : console_logger                                                    *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 2000-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "console_logger.h"

#include <basis/istring.h>
#include <basis/mutex.h>
#include <basis/utility.h>

#include <stdio.h>

console_logger::console_logger() {}

console_logger::~console_logger() {}

outcome console_logger::log(const istring &info, int filter)
{
  if (member(filter)) {
    printf("%s", info.s());  // do a format to ensure we get all characters.
    if (eol() != NO_ENDING) printf((char *)get_ending().s());
    fflush(stdout);  // write immediately to avoid lost output on crash.
  }
  return common::OKAY;
}

#ifndef OMIT_PROGRAM_WIDE_LOGGER
log_base *set_PW_logger_for_console()
{
  console_logger *new_pw = new console_logger();
  return retask_program_wide_logger(new_pw);
}
#endif

