/*****************************************************************************\
*                                                                             *
*  Name   : item_statistics                                                   *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 2000-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "item_statistics.h"

#include <basis/function.h>
#include <basis/istring.h>

istring item_statistics::text_form() const
{
  istring to_return;
  to_return += "entered at {";
  to_return += adjusted_representation(entry);
  to_return += "}, exited at {";
  to_return += adjusted_representation(exit);
  to_return += istring(istring::SPRINTF, "}, based on %d activations, "
      "average was %d ms.", durations.samples(), durations.average());
  return to_return;
}

istring item_statistics::adjusted_representation
    (const guarded_value<time_stamp> &to_show) const
{
  if (!to_show.initialized()) return "invalid";
  else return time_stamp(to_show).text_form();
}

